// GluonClientProvider.java - Access GluonCloudLink
// Copyright 2016, Anderson Software Group, Inc.
// Gail and Paul Anderson

package com.asgteach.bpcloud.service;

import com.gluonhq.connect.gluoncloud.AuthenticationMode;
import com.gluonhq.connect.gluoncloud.GluonClient;
import com.gluonhq.connect.gluoncloud.GluonClientBuilder;
import com.gluonhq.connect.gluoncloud.GluonCredentials;

/**
 *
 * @author gail
 */
public class GluonClientProvider {
    // Register your application through the Gluon Cloud portal
    // and supply your application's key and secret here.
    private static final String APPKEY = "your app key";
    private static final String APPSECRET = "your secret key";
    
    private static GluonClient gluonClient;

    // AuthenticationMode.USER requires user authentication
    // Currently support only authentication via Twitter.
    public static GluonClient getGluonClient() {
        if (gluonClient == null) {
            gluonClient = GluonClientBuilder.create()
                    .credentials(new GluonCredentials(APPKEY, APPSECRET))
                    .authenticationMode(AuthenticationMode.USER)
                    .build();
        }
        return gluonClient;
    }
    
}
