/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.asgteach.bpmonitor.service;

import com.asgteach.bpmonitor.model.BPData;
import com.gluonhq.connect.ConnectState;
import com.gluonhq.connect.GluonObservableList;
import com.gluonhq.connect.gluoncloud.GluonClient;
import com.gluonhq.connect.gluoncloud.GluonClientBuilder;
import com.gluonhq.connect.gluoncloud.OperationMode;
import com.gluonhq.connect.gluoncloud.SyncFlag;
import com.gluonhq.connect.provider.DataProvider;
import javafx.beans.property.ListProperty;
import javafx.beans.property.SimpleListProperty;
import javafx.collections.FXCollections;
import javax.annotation.PostConstruct;

/**
 *
 * @author gail
 */


public class Service {

    private static final String BPDATA = "bpdata-v1";

    private final ListProperty<BPData> bpList = 
            new SimpleListProperty<>(FXCollections.observableArrayList());

    private GluonClient gluonClient;

    @PostConstruct
    public void postConstruct() {
        gluonClient = GluonClientBuilder.create()
                .operationMode(OperationMode.LOCAL_ONLY)
                .build();
    }

    public void retrieveReadings() {
        GluonObservableList<BPData> gluonBPData = DataProvider.<BPData>retrieveList(
                gluonClient.createListDataReader(BPDATA, BPData.class,
                SyncFlag.LIST_WRITE_THROUGH, SyncFlag.OBJECT_WRITE_THROUGH));

        gluonBPData.stateProperty().addListener((obs, ov, nv) -> {
            if (ConnectState.SUCCEEDED.equals(nv)) {
                System.out.println("Service-retrieveReadings : connection succeeded.");
                bpList.set(gluonBPData);
            }
        });
    }

    public BPData addReading(BPData data) {
        bpList.get().add(data);
        return data;
    }

    public void removeReading(BPData data) {
        bpList.get().remove(data);
    }

    public ListProperty<BPData> bpListProperty() {
        return bpList;
    }
    
    public void clear() {
        System.out.println("clearing " + bpList.get().size() + " items.");
        bpList.get().clear();
    }

}


